# Credit to shanewolf38 for basic maze generator
# https://www.planetminecraft.com/data-pack/1-13-insanely-fast-maze-generator/

#Change floors
scoreboard players set .moveVer maze 1
scoreboard players set .modulo random 3
function cc:generation/random/num
execute unless block ~ 49 ~-8 air run scoreboard players set .moveVer maze 1
execute if block ~8 49 ~ air if block ~ 49 ~8 air if block ~-8 49 ~ air if block ~ 49 ~-8 air run scoreboard players operation .moveVer maze = .output random

#Test directions
scoreboard players set .total randomID 0
scoreboard players set @e[type=minecraft:area_effect_cloud,tag=mazeDir] randomID -1

execute if block ~8 ~ ~ minecraft:lime_concrete if block ~4 ~14 ~ spruce_planks as @e[tag=mazeDir,scores={maze=1},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if block ~ ~ ~8 minecraft:lime_concrete if block ~ ~ ~4 air if block ~ ~14 ~4 spruce_planks as @e[tag=mazeDir,scores={maze=2},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if block ~-8 ~ ~ minecraft:lime_concrete if block ~-4 ~14 ~ spruce_planks as @e[tag=mazeDir,scores={maze=3},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if block ~ ~ ~-8 minecraft:lime_concrete if block ~ ~ ~-4 air if block ~ ~14 ~-4 spruce_planks as @e[tag=mazeDir,scores={maze=4},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id

execute if score .moveVer maze matches 0 if score chosenDir maze matches 1 unless block ~ ~-7 ~ minecraft:air if block ~ ~-4 ~ air if block ~8 ~-7 ~ minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=5},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if score .moveVer maze matches 0 if score chosenDir maze matches 2 unless block ~ ~-7 ~ minecraft:air if block ~ ~-4 ~ air if block ~ ~-7 ~8 minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=6},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if score .moveVer maze matches 0 if score chosenDir maze matches 3 unless block ~ ~-7 ~ minecraft:air if block ~ ~-4 ~ air if block ~-8 ~-7 ~ minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=7},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if score .moveVer maze matches 0 if score chosenDir maze matches 4 unless block ~ ~-7 ~ minecraft:air if block ~ ~-4 ~ air if block ~ ~-7 ~-8 minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=8},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if score .moveVer maze matches 0 if score chosenDir maze matches 1 unless block ~ ~7 ~ minecraft:air if block ~ ~3 ~ air if block ~8 ~7 ~ minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=9},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if score .moveVer maze matches 0 if score chosenDir maze matches 2 unless block ~ ~7 ~ minecraft:air if block ~ ~3 ~ air if block ~ ~7 ~4 air if block ~ ~7 ~8 minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=10},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if score .moveVer maze matches 0 if score chosenDir maze matches 3 unless block ~ ~7 ~ minecraft:air if block ~ ~3 ~ air if block ~-8 ~7 ~ minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=11},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if score .moveVer maze matches 0 if score chosenDir maze matches 4 unless block ~ ~7 ~ minecraft:air if block ~ ~3 ~ air if block ~ ~7 ~-4 air if block ~ ~7 ~-8 minecraft:lime_concrete as @e[tag=mazeDir,scores={maze=12},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id

scoreboard players operation .modulo random = .total randomID

#Select direction
scoreboard players set chosenDir maze 0
function cc:generation/random/num
execute as @e[type=area_effect_cloud,tag=mazeDir] if score @s randomID = .output random run scoreboard players operation chosenDir maze = @s maze

#If chosen
execute if score chosenDir maze matches 1.. run setblock ~ ~ ~ red_concrete
execute if score chosenDir maze matches 5..8 run setblock ~ ~-7 ~ red_concrete
execute if score chosenDir maze matches 9..12 run setblock ~ ~7 ~ red_concrete
execute if score chosenDir maze matches 5 run setblock ~ ~-4 ~ blue_concrete
execute if score chosenDir maze matches 6 run setblock ~ ~-4 ~ red_concrete
execute if score chosenDir maze matches 7 run setblock ~ ~-4 ~ yellow_concrete
execute if score chosenDir maze matches 8 run setblock ~ ~-4 ~ green_concrete
execute if score chosenDir maze matches 9 run setblock ~ ~3 ~ yellow_concrete
execute if score chosenDir maze matches 10 run setblock ~ ~3 ~ green_concrete
execute if score chosenDir maze matches 11 run setblock ~ ~3 ~ blue_concrete
execute if score chosenDir maze matches 12 run setblock ~ ~3 ~ red_concrete

#Make doorway / remove wall
execute if score chosenDir maze matches 1 run fill ~4 ~10 ~1 ~4 ~12 ~-1 air
execute if score chosenDir maze matches 1 if block 0 ~-2 0 white_concrete run fill ~4 100 ~1 ~4 100 ~-1 blue_stained_glass
execute if score chosenDir maze matches 1 if block 0 ~-2 0 black_concrete run fill ~4 100 ~129 ~4 100 ~127 blue_stained_glass
execute if score chosenDir maze matches 1 positioned ~8 ~ ~ run function cc:generation/maze
execute if score chosenDir maze matches 2 run fill ~1 ~10 ~4 ~-1 ~12 ~4 air
execute if score chosenDir maze matches 2 if block 0 ~-2 0 white_concrete run fill ~1 100 ~4 ~-1 100 ~4 blue_stained_glass
execute if score chosenDir maze matches 2 if block 0 ~-2 0 black_concrete run fill ~1 100 ~132 ~-1 100 ~132 blue_stained_glass
execute if score chosenDir maze matches 2 positioned ~ ~ ~8 run function cc:generation/maze
execute if score chosenDir maze matches 3 run fill ~-4 ~10 ~1 ~-4 ~12 ~-1 air
execute if score chosenDir maze matches 3 if block 0 ~-2 0 white_concrete run fill ~-4 100 ~1 ~-4 100 ~-1 blue_stained_glass
execute if score chosenDir maze matches 3 if block 0 ~-2 0 black_concrete run fill ~-4 100 ~129 ~-4 100 ~127 blue_stained_glass
execute if score chosenDir maze matches 3 positioned ~-8 ~ ~ run function cc:generation/maze
execute if score chosenDir maze matches 4 run fill ~1 ~10 ~-4 ~-1 ~12 ~-4 air
execute if score chosenDir maze matches 4 if block 0 ~-2 0 white_concrete run fill ~1 100 ~-4 ~-1 100 ~-4 blue_stained_glass
execute if score chosenDir maze matches 4 if block 0 ~-2 0 black_concrete run fill ~1 100 ~124 ~-1 100 ~124 blue_stained_glass
execute if score chosenDir maze matches 4 positioned ~ ~ ~-8 run function cc:generation/maze

execute if score chosenDir maze matches 5 run fill ~4 ~3 ~1 ~4 ~6 ~-1 air
execute if score chosenDir maze matches 5 run fill ~4 ~7 ~1 ~4 ~7 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 5 run fill ~-4 ~14 ~1 ~-4 ~14 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 5 run fill ~-4 ~13 ~1 ~-4 ~13 ~-1 air
execute if score chosenDir maze matches 5 run fill ~4 100 ~1 ~4 100 ~-1 blue_stained_glass
execute if score chosenDir maze matches 5 positioned ~ 100 ~ run function cc:generation/map/stair_west
execute if score chosenDir maze matches 5 positioned ~8 ~-7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 6 run fill ~1 ~3 ~4 ~-1 ~6 ~4 air
execute if score chosenDir maze matches 6 run fill ~1 ~7 ~4 ~-1 ~7 ~4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 6 run fill ~1 ~14 ~-4 ~-1 ~14 ~-4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 6 run fill ~1 ~13 ~-4 ~-1 ~13 ~-4 air
execute if score chosenDir maze matches 6 run fill ~1 100 ~4 ~-1 100 ~4 blue_stained_glass
execute if score chosenDir maze matches 6 positioned ~ 100 ~ run function cc:generation/map/stair_north
execute if score chosenDir maze matches 6 positioned ~ ~-7 ~8 run function cc:generation/maze
execute if score chosenDir maze matches 7 run fill ~-4 ~3 ~1 ~-4 ~6 ~-1 air
execute if score chosenDir maze matches 7 run fill ~-4 ~7 ~1 ~-4 ~7 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 7 run fill ~4 ~14 ~1 ~4 ~14 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 7 run fill ~4 ~13 ~1 ~4 ~13 ~-1 air
execute if score chosenDir maze matches 7 run fill ~-4 100 ~1 ~-4 100 ~-1 blue_stained_glass
execute if score chosenDir maze matches 7 positioned ~ 100 ~ run function cc:generation/map/stair_east
execute if score chosenDir maze matches 7 positioned ~-8 ~-7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 8 run fill ~1 ~3 ~-4 ~-1 ~6 ~-4 air
execute if score chosenDir maze matches 8 run fill ~1 ~7 ~-4 ~-1 ~7 ~-4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 8 run fill ~1 ~14 ~4 ~-1 ~14 ~4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 8 run fill ~1 ~13 ~4 ~-1 ~13 ~4 air
execute if score chosenDir maze matches 8 run fill ~1 100 ~-4 ~-1 100 ~-4 blue_stained_glass
execute if score chosenDir maze matches 8 positioned ~ 100 ~ run function cc:generation/map/stair_south
execute if score chosenDir maze matches 8 positioned ~ ~-7 ~-8 run function cc:generation/maze

execute if score chosenDir maze matches 9 run fill ~4 ~17 ~1 ~4 ~20 ~-1 air
execute if score chosenDir maze matches 9 run fill ~4 ~21 ~1 ~4 ~21 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 9 run fill ~-4 ~14 ~1 ~-4 ~14 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 9 run fill ~-4 ~13 ~1 ~-4 ~13 ~-1 air
execute if score chosenDir maze matches 9 run fill ~4 100 ~129 ~4 100 ~127 blue_stained_glass
execute if score chosenDir maze matches 9 positioned ~ 100 ~ run function cc:generation/map/stair_east
execute if score chosenDir maze matches 9 positioned ~8 ~7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 10 run fill ~1 ~17 ~4 ~-1 ~20 ~4 air
execute if score chosenDir maze matches 10 run fill ~1 ~21 ~4 ~-1 ~21 ~4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 10 run fill ~1 ~14 ~-4 ~-1 ~14 ~-4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 10 run fill ~1 ~13 ~-4 ~-1 ~13 ~-4 air
execute if score chosenDir maze matches 10 run fill ~1 100 ~132 ~-1 100 ~132 blue_stained_glass
execute if score chosenDir maze matches 10 positioned ~ 100 ~ run function cc:generation/map/stair_south
execute if score chosenDir maze matches 10 positioned ~ ~7 ~8 run function cc:generation/maze
execute if score chosenDir maze matches 11 run fill ~-4 ~17 ~1 ~-4 ~20 ~-1 air
execute if score chosenDir maze matches 11 run fill ~-4 ~21 ~1 ~-4 ~21 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 11 run fill ~4 ~14 ~1 ~4 ~14 ~-1 stripped_spruce_log[axis=z]
execute if score chosenDir maze matches 11 run fill ~4 ~13 ~1 ~4 ~13 ~-1 air
execute if score chosenDir maze matches 11 run fill ~-4 100 ~129 ~-4 100 ~127 blue_stained_glass
execute if score chosenDir maze matches 11 positioned ~ 100 ~ run function cc:generation/map/stair_west
execute if score chosenDir maze matches 11 positioned ~-8 ~7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 12 run fill ~1 ~17 ~-4 ~-1 ~20 ~-4 air
execute if score chosenDir maze matches 12 run fill ~1 ~21 ~-4 ~-1 ~21 ~-4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 12 run fill ~1 ~14 ~4 ~-1 ~14 ~4 stripped_spruce_log[axis=x]
execute if score chosenDir maze matches 12 run fill ~1 ~13 ~4 ~-1 ~13 ~4 air
execute if score chosenDir maze matches 12 run fill ~1 100 ~124 ~-1 100 ~124 blue_stained_glass
execute if score chosenDir maze matches 12 positioned ~ 100 ~ run function cc:generation/map/stair_north
execute if score chosenDir maze matches 12 positioned ~ ~7 ~-8 run function cc:generation/maze

#Backtrack
execute if score chosenDir maze matches 0 run setblock ~ ~ ~ blue_concrete
execute if score chosenDir maze matches 0 unless block ~ ~-4 ~ air run setblock ~ ~-7 ~ blue_concrete
execute if score chosenDir maze matches 0 unless block ~ ~3 ~ air run setblock ~ ~7 ~ blue_concrete
execute if score chosenDir maze matches 0 if block ~4 ~10 ~ air if block ~8 ~ ~ red_concrete if block ~4 ~14 ~ spruce_planks positioned ~8 ~ ~ run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~ ~10 ~4 air if block ~ ~ ~8 red_concrete if block ~ ~14 ~4 spruce_planks positioned ~ ~ ~8 run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~-4 ~10 ~ air if block ~-8 ~ ~ red_concrete if block ~-4 ~14 ~ spruce_planks positioned ~-8 ~ ~ run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~ ~10 ~-4 air if block ~ ~ ~-8 red_concrete if block ~ ~14 ~-4 spruce_planks positioned ~ ~ ~-8 run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~8 ~-4 ~ blue_concrete if block ~16 ~-7 ~ red_concrete positioned ~16 ~-7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~ ~-4 ~8 red_concrete if block ~ ~-7 ~16 red_concrete positioned ~ ~-7 ~16 run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~-8 ~-4 ~ yellow_concrete if block ~-16 ~-7 ~ red_concrete positioned ~-16 ~-7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~ ~-4 ~-8 green_concrete if block ~ ~-7 ~-16 red_concrete positioned ~ ~-7 ~-16 run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~8 ~3 ~ yellow_concrete if block ~16 ~7 ~ red_concrete positioned ~16 ~7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~ ~3 ~8 green_concrete if block ~ ~7 ~16 red_concrete positioned ~ ~7 ~16 run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~-8 ~3 ~ blue_concrete if block ~-16 ~7 ~ red_concrete positioned ~-16 ~7 ~ run function cc:generation/maze
execute if score chosenDir maze matches 0 if block ~ ~3 ~-8 red_concrete if block ~ ~7 ~-16 red_concrete positioned ~ ~7 ~-16 run function cc:generation/maze