scoreboard players set .modulo random 1
scoreboard players set isRoom maze 2

#Decrease chances if nearby rooms
execute if block ~8 ~-1 ~ #cc:room_type run scoreboard players add .modulo random 3
execute if block ~ ~-1 ~8 #cc:room_type run scoreboard players add .modulo random 3
execute if block ~-8 ~-1 ~ #cc:room_type run scoreboard players add .modulo random 3
execute if block ~ ~-1 ~-8 #cc:room_type run scoreboard players add .modulo random 3
execute if block ~8 ~-1 ~8 #cc:room_type run scoreboard players add .modulo random 2
execute if block ~8 ~-1 ~-8 #cc:room_type run scoreboard players add .modulo random 2
execute if block ~-8 ~-1 ~-8 #cc:room_type run scoreboard players add .modulo random 2
execute if block ~-8 ~-1 ~8 #cc:room_type run scoreboard players add .modulo random 2

function cc:generation/random/num
execute if block ~ ~ ~ blue_concrete if block ~ ~-1 ~ white_concrete run scoreboard players operation isRoom maze = .output random

#If chosen as room
execute if score isRoom maze matches 0 run function cc:generation/room_start

#Test directions
scoreboard players set .total randomID 0
scoreboard players set @e[type=minecraft:area_effect_cloud,tag=mazeDir] randomID -1

execute if block ~8 ~ ~ minecraft:blue_concrete as @e[tag=mazeDir,scores={maze=1},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if block ~ ~ ~8 minecraft:blue_concrete as @e[tag=mazeDir,scores={maze=2},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if block ~-8 ~ ~ minecraft:blue_concrete as @e[tag=mazeDir,scores={maze=3},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id
execute if block ~ ~ ~-8 minecraft:blue_concrete as @e[tag=mazeDir,scores={maze=4},type=minecraft:area_effect_cloud] run function cc:generation/random/assign_id

scoreboard players operation .modulo random = .total randomID

#Select direction
scoreboard players set chosenDir maze 0
function cc:generation/random/num
execute as @e[type=area_effect_cloud,tag=mazeDir] if score @s randomID = .output random run scoreboard players operation chosenDir maze = @s maze

#If chosen
execute if score chosenDir maze matches 1.. run setblock ~ ~ ~ red_concrete

#Move in direction
execute if score chosenDir maze matches 1 positioned ~8 ~ ~ run function cc:generation/room_seed
execute if score chosenDir maze matches 2 positioned ~ ~ ~8 run function cc:generation/room_seed
execute if score chosenDir maze matches 3 positioned ~-8 ~ ~ run function cc:generation/room_seed
execute if score chosenDir maze matches 4 positioned ~ ~ ~-8 run function cc:generation/room_seed

#Backtrack
execute if score chosenDir maze matches 0 run setblock ~ ~ ~ purple_concrete
execute if score chosenDir maze matches 0 if block ~8 ~ ~ red_concrete positioned ~8 ~ ~ run function cc:generation/room_seed
execute if score chosenDir maze matches 0 if block ~ ~ ~8 red_concrete positioned ~ ~ ~8 run function cc:generation/room_seed
execute if score chosenDir maze matches 0 if block ~-8 ~ ~ red_concrete positioned ~-8 ~ ~ run function cc:generation/room_seed
execute if score chosenDir maze matches 0 if block ~ ~ ~-8 red_concrete positioned ~ ~ ~-8 run function cc:generation/room_seed