#Test walls
scoreboard players set wall1 maze 0
scoreboard players set wall2 maze 0
scoreboard players set wall3 maze 0
scoreboard players set wall4 maze 0
scoreboard players set downStair maze 0
scoreboard players set upStair maze 0

execute if block ~3 ~10 ~-4 stone_bricks run scoreboard players set wall1 maze 1
execute if block ~ ~10 ~-4 stone_bricks run scoreboard players set wall1 maze 2
execute if block ~4 ~10 ~3 stone_bricks run scoreboard players set wall2 maze 1
execute if block ~4 ~10 ~ stone_bricks run scoreboard players set wall2 maze 2
execute if block ~3 ~10 ~4 stone_bricks run scoreboard players set wall3 maze 1
execute if block ~ ~10 ~4 stone_bricks run scoreboard players set wall3 maze 2
execute if block ~-4 ~10 ~3 stone_bricks run scoreboard players set wall4 maze 1
execute if block ~-4 ~10 ~ stone_bricks run scoreboard players set wall4 maze 2
execute if block ~ ~3 ~ red_concrete run scoreboard players set downStair maze 1
execute if block ~ ~3 ~ yellow_concrete run scoreboard players set downStair maze 2
execute if block ~ ~3 ~ green_concrete run scoreboard players set downStair maze 3
execute if block ~ ~3 ~ blue_concrete run scoreboard players set downStair maze 4
execute if block ~ ~-4 ~ red_concrete run scoreboard players set upStair maze 1
execute if block ~ ~-4 ~ yellow_concrete run scoreboard players set upStair maze 2
execute if block ~ ~-4 ~ green_concrete run scoreboard players set upStair maze 3
execute if block ~ ~-4 ~ blue_concrete run scoreboard players set upStair maze 4

execute if score downStair maze matches 1..4 run function cc:generation/tiles/sum_walls
execute if score upStair maze matches 1..4 run function cc:generation/tiles/sum_walls

setblock ~ ~ ~ orange_concrete

function cc:generation/tiles/calculate_frequency

#Pick tile based on walls
execute if block ~ ~-1 ~ white_concrete run function cc:generation/tiles/choose_generic
execute if block ~ ~-1 ~ black_concrete run function cc:generation/tiles/choose_generic
execute if block ~ ~-1 ~ red_concrete run function cc:generation/tiles/choose_kitchen
execute if block ~ ~-1 ~ blue_glazed_terracotta run function cc:generation/tiles/choose_bedroom
execute if block ~ ~-1 ~ blue_concrete run function cc:generation/tiles/choose_bedroom_extra
execute if block ~ ~-1 ~ lime_concrete run function cc:generation/tiles/choose_garden
execute if block ~ ~-1 ~ purple_concrete run function cc:generation/tiles/choose_dining
execute if block ~ ~-1 ~ yellow_concrete run function cc:generation/tiles/choose_library
execute if block ~ ~-1 ~ light_gray_glazed_terracotta run function cc:generation/tiles/choose_storage
execute if block ~ ~-1 ~ green_concrete run function cc:generation/tiles/choose_fitness
execute if block ~ ~-1 ~ orange_concrete run function cc:generation/tiles/choose_entertainment
execute if block ~ ~-1 ~ magenta_concrete run function cc:generation/tiles/choose_magic
execute if block ~ ~-1 ~ gray_glazed_terracotta run function cc:generation/tiles/choose_torture
execute if block ~ ~-1 ~ yellow_glazed_terracotta run function cc:generation/tiles/choose_vault
execute if block ~ ~-1 ~ red_glazed_terracotta run function cc:generation/tiles/choose_redstone

#Continue grid on sides
execute unless block ~8 ~ ~ air unless block ~8 ~ ~ orange_concrete unless block ~8 ~ ~ pink_concrete positioned ~8 ~ ~ run function cc:generation/tiles/pick_tiles
execute unless block ~ ~ ~8 air unless block ~ ~ ~8 orange_concrete unless block ~ ~ ~8 pink_concrete positioned ~ ~ ~8 run function cc:generation/tiles/pick_tiles
execute unless block ~-8 ~ ~ air unless block ~-8 ~ ~ orange_concrete unless block ~-8 ~ ~ pink_concrete positioned ~-8 ~ ~ run function cc:generation/tiles/pick_tiles
execute unless block ~ ~ ~-8 air unless block ~ ~ ~-8 orange_concrete unless block ~ ~ ~-8 pink_concrete positioned ~ ~ ~-8 run function cc:generation/tiles/pick_tiles