#Grows room from seed
scoreboard players set growRoom maze 4
scoreboard players set .reroll maze 0

#Define area
execute if block ~8 ~-1 ~ white_concrete run setblock ~8 ~-1 ~ white_terracotta
execute if block ~ ~-1 ~8 white_concrete run setblock ~ ~-1 ~8 white_terracotta
execute if block ~-8 ~-1 ~ white_concrete run setblock ~-8 ~-1 ~ white_terracotta
execute if block ~ ~-1 ~-8 white_concrete run setblock ~ ~-1 ~-8 white_terracotta
execute if block ~8 ~-1 ~8 white_concrete run setblock ~8 ~-1 ~8 white_terracotta
execute if block ~8 ~-1 ~-8 white_concrete run setblock ~8 ~-1 ~-8 white_terracotta
execute if block ~-8 ~-1 ~-8 white_concrete run setblock ~-8 ~-1 ~-8 white_terracotta
execute if block ~-8 ~-1 ~8 white_concrete run setblock ~-8 ~-1 ~8 white_terracotta

setblock ~ ~-1 ~ gray_concrete

function cc:generation/room_growth_pick

execute if block ~ ~-1 ~ gray_terracotta run setblock ~ ~-1 ~ gray_concrete
execute if block ~8 ~-1 ~ gray_terracotta run setblock ~8 ~-1 ~ gray_concrete
execute if block ~ ~-1 ~8 gray_terracotta run setblock ~ ~-1 ~8 gray_concrete
execute if block ~-8 ~-1 ~ gray_terracotta run setblock ~-8 ~-1 ~ gray_concrete
execute if block ~ ~-1 ~-8 gray_terracotta run setblock ~ ~-1 ~-8 gray_concrete
execute if block ~8 ~-1 ~8 gray_terracotta run setblock ~8 ~-1 ~8 gray_concrete
execute if block ~8 ~-1 ~-8 gray_terracotta run setblock ~8 ~-1 ~-8 gray_concrete
execute if block ~-8 ~-1 ~-8 gray_terracotta run setblock ~-8 ~-1 ~-8 gray_concrete
execute if block ~-8 ~-1 ~8 gray_terracotta run setblock ~-8 ~-1 ~8 gray_concrete

#Clear walls
execute if block ~8 ~-1 ~ gray_concrete run fill ~4 ~10 ~3 ~4 ~15 ~-3 air
execute if block ~ ~-1 ~8 gray_concrete run fill ~3 ~10 ~4 ~-3 ~15 ~4 air
execute if block ~-8 ~-1 ~ gray_concrete run fill ~-4 ~10 ~3 ~-4 ~15 ~-3 air
execute if block ~ ~-1 ~-8 gray_concrete run fill ~3 ~10 ~-4 ~-3 ~15 ~-4 air

execute if block ~8 ~-1 ~8 gray_concrete if block ~8 ~-1 ~ gray_concrete run fill ~11 ~10 ~4 ~5 ~15 ~4 air
execute if block ~8 ~-1 ~8 gray_concrete if block ~ ~-1 ~8 gray_concrete run fill ~4 ~10 ~11 ~4 ~15 ~5 air
execute if block ~8 ~-1 ~8 gray_concrete if block ~8 ~-1 ~ gray_concrete if block ~ ~-1 ~8 gray_concrete run fill ~4 ~10 ~4 ~4 ~15 ~4 air

execute if block ~8 ~-1 ~-8 gray_concrete if block ~8 ~-1 ~ gray_concrete run fill ~11 ~10 ~-4 ~5 ~15 ~-4 air
execute if block ~8 ~-1 ~-8 gray_concrete if block ~ ~-1 ~-8 gray_concrete run fill ~4 ~10 ~-11 ~4 ~15 ~-5 air
execute if block ~8 ~-1 ~-8 gray_concrete if block ~8 ~-1 ~ gray_concrete if block ~ ~-1 ~-8 gray_concrete run fill ~4 ~10 ~-4 ~4 ~15 ~-4 air

execute if block ~-8 ~-1 ~-8 gray_concrete if block ~-8 ~-1 ~ gray_concrete run fill ~-11 ~10 ~-4 ~-5 ~15 ~-4 air
execute if block ~-8 ~-1 ~-8 gray_concrete if block ~ ~-1 ~-8 gray_concrete run fill ~-4 ~10 ~-11 ~-4 ~15 ~-5 air
execute if block ~-8 ~-1 ~-8 gray_concrete if block ~-8 ~-1 ~ gray_concrete if block ~ ~-1 ~-8 gray_concrete run fill ~-4 ~10 ~-4 ~-4 ~15 ~-4 air

execute if block ~-8 ~-1 ~8 gray_concrete if block ~-8 ~-1 ~ gray_concrete run fill ~-11 ~10 ~4 ~-5 ~15 ~4 air
execute if block ~-8 ~-1 ~8 gray_concrete if block ~ ~-1 ~8 gray_concrete run fill ~-4 ~10 ~11 ~-4 ~15 ~5 air
execute if block ~-8 ~-1 ~8 gray_concrete if block ~-8 ~-1 ~ gray_concrete if block ~ ~-1 ~8 gray_concrete run fill ~-4 ~10 ~4 ~-4 ~15 ~4 air

#Map
execute if block 0 ~-2 0 white_concrete run function cc:generation/map/room_growth
execute if block 0 ~-2 0 black_concrete run function cc:generation/map/room_growth_top

#Check for stairs
execute unless block ~ 49 ~ air run scoreboard players set .stairRoom maze 1
execute if block ~8 ~-1 ~ gray_concrete unless block ~8 49 ~ air run scoreboard players set .stairRoom maze 1
execute if block ~ ~-1 ~8 gray_concrete unless block ~ 49 ~8 air run scoreboard players set .stairRoom maze 1
execute if block ~-8 ~-1 ~ gray_concrete unless block ~-8 49 ~ air run scoreboard players set .stairRoom maze 1
execute if block ~ ~-1 ~-8 gray_concrete unless block ~ 49 ~-8 air run scoreboard players set .stairRoom maze 1
execute if block ~8 ~-1 ~8 gray_concrete unless block ~8 49 ~8 air run scoreboard players set .stairRoom maze 1
execute if block ~8 ~-1 ~-8 gray_concrete unless block ~8 49 ~-8 air run scoreboard players set .stairRoom maze 1
execute if block ~-8 ~-1 ~-8 gray_concrete unless block ~-8 49 ~-8 air run scoreboard players set .stairRoom maze 1
execute if block ~-8 ~-1 ~8 gray_concrete unless block ~-8 49 ~8 air run scoreboard players set .stairRoom maze 1

execute if block ~8 ~-1 ~ white_terracotta run setblock ~8 ~-1 ~ white_concrete
execute if block ~ ~-1 ~8 white_terracotta run setblock ~ ~-1 ~8 white_concrete
execute if block ~-8 ~-1 ~ white_terracotta run setblock ~-8 ~-1 ~ white_concrete
execute if block ~ ~-1 ~-8 white_terracotta run setblock ~ ~-1 ~-8 white_concrete
execute if block ~8 ~-1 ~8 white_terracotta run setblock ~8 ~-1 ~8 white_concrete
execute if block ~8 ~-1 ~-8 white_terracotta run setblock ~8 ~-1 ~-8 white_concrete
execute if block ~-8 ~-1 ~-8 white_terracotta run setblock ~-8 ~-1 ~-8 white_concrete
execute if block ~-8 ~-1 ~8 white_terracotta run setblock ~-8 ~-1 ~8 white_concrete
