import os

directory = os.getcwd()

def add_rooms_to_file(file_path, end_num, roomType, letter):
    with open(file_path, 'r') as reader:
        lines = reader.readlines()
    new_file_path = file_path.replace('backup', roomType)

    with open(new_file_path, 'w') as writer:
        for i in range(0, (len(lines) - 1)):
            if i == 1:
                writer.write(lines[i].replace('1', str(end_num)))
            else:
                writer.write(lines[i])
        for i in range(1, end_num + 1):
            room_line = lines[len(lines) - 1].replace('_1', ('_1' + letter), 1).replace('1', str(i), 2)
            writer.write(room_line)


def choose_rooms(tile, num, roomType, letter):
    for entry in os.scandir(directory):
        if (entry.path.endswith(".mcfunction")) and entry.is_file() and tile in entry.path:
            add_rooms_to_file(entry.path, num, roomType, letter)


tileType = input("Tile type: ")
number = input("Number of room types: ")
roomType = input("Room type: ")
roomLetter = input("Room letter: ")

choose_rooms(tileType, int(number), roomType, roomLetter)

k = input("Press enter to exit")
