import os

directory = os.getcwd()


def edit_item(filePath, itemID, itemScore, itemName, itemLore, fileName):
    with open(filePath, 'r') as reader:
        lines = reader.readlines()
    newFilePath = filePath.replace('example', fileName)

    with open(newFilePath, 'w') as writer:
        for i in range(0, len(lines)):
            writer.write(lines[i].replace('#itemID', itemID).replace('#itemScore', itemScore).replace('#itemName', itemName).replace('#itemLore', itemLore))

def add_item(filePath, itemID, itemScore, fileName):
    with open(filePath, 'r') as reader:
        lines = reader.readlines()

    with open(filePath, 'w') as writer:
        for i in range(0, len(lines)):
            newLine = lines[i].replace("#countItems", "execute as @s[nbt={SelectedItem:{tag:{ccItem:" + itemID +
                                       "}}}] run scoreboard players operation @s itemCount = @s " + itemScore + "\n#countItems")
            newLine = newLine.replace("#itemReload", "function cc:item/" + fileName + "/reload" + "\n#itemReload")
            newLine = newLine.replace("#resetCount", "scoreboard players set @a " + itemScore + " 0" + "\n#resetCount")
            newLine = newLine.replace("#itemSave", "execute as @s[nbt={Inventory:[{tag:{ccItem:" + itemID +
                                      "}}]}] run function cc:item/" + fileName + "/detect" + "\n#itemSave")
            newLine = newLine.replace("#resetDisplay", "scoreboard players remove @a[scores={" + itemScore + "Timer=1..}] " + 
                                      itemScore + "Timer 1\nscoreboard players set @a[scores={" + itemScore + "Timer=..0}] " + itemScore + "Recent 0" + "\n#resetDisplay")
            writer.write(newLine)

def pick_item(itemID, itemScore, itemName, itemLore, fileName):
    for entry in os.scandir(directory):
        if (entry.path.endswith(".mcfunction")) and entry.is_file():
            edit_item(entry.path, itemID, itemScore, itemName, itemLore, fileName)
    for entry in os.scandir(directory.replace(r"\example", "")):
        if (entry.path.endswith(".mcfunction")) and entry.is_file():
            add_item(entry.path, itemID, itemScore, fileName)

itemID = input("ItemID: ")
itemScore = input("ItemScore: ")
itemName = input("ItemName: ")
itemLore = input("ItemLore: ")
fileName = input("FileName: ")

pick_item(itemID, itemScore, itemName, itemLore, fileName)

close = input("Press enter to finish")
